# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from clearpath_localization_msgs/GNSSStatus.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class GNSSStatus(genpy.Message):
  _md5sum = "3fde27dc2ceba2593ee0c1c4446aa2cb"
  _type = "clearpath_localization_msgs/GNSSStatus"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Message definition containing the GNSS receiver status information.

uint8 POSITION_RECEIVER = 0
uint8 HEADING_RECEIVER = 1
uint8 BASE_STATION_RECEIVER = 2
uint8 receiver_type

uint8 POSITION_NO_FIX = 0
uint8 POSITION_SPP = 1
uint8 POSITION_SBAS = 2
uint8 POSITION_RTK_FLOAT = 3
uint8 POSITION_RTK_FIXED = 4
uint8 position_fix_type

uint8 HEADING_NOT_APPLICABLE = 0
uint8 HEADING_NO_SOLUTION = 1
uint8 HEADING_RTK_FLOAT = 2
uint8 HEADING_RTK_FIXED = 3
uint8 heading_fix_type

uint8 num_connected_sats	# Number of satellites connected to the antenna/receiver
uint8 num_sats_solution   # Number of sats used in solution
float32[] cn0			        # The carrier-to-noise ratio of each connected satellite
float64 correction_age    # Age of RTK corrections. -1 indicates none received
"""
  # Pseudo-constants
  POSITION_RECEIVER = 0
  HEADING_RECEIVER = 1
  BASE_STATION_RECEIVER = 2
  POSITION_NO_FIX = 0
  POSITION_SPP = 1
  POSITION_SBAS = 2
  POSITION_RTK_FLOAT = 3
  POSITION_RTK_FIXED = 4
  HEADING_NOT_APPLICABLE = 0
  HEADING_NO_SOLUTION = 1
  HEADING_RTK_FLOAT = 2
  HEADING_RTK_FIXED = 3

  __slots__ = ['receiver_type','position_fix_type','heading_fix_type','num_connected_sats','num_sats_solution','cn0','correction_age']
  _slot_types = ['uint8','uint8','uint8','uint8','uint8','float32[]','float64']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       receiver_type,position_fix_type,heading_fix_type,num_connected_sats,num_sats_solution,cn0,correction_age

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(GNSSStatus, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.receiver_type is None:
        self.receiver_type = 0
      if self.position_fix_type is None:
        self.position_fix_type = 0
      if self.heading_fix_type is None:
        self.heading_fix_type = 0
      if self.num_connected_sats is None:
        self.num_connected_sats = 0
      if self.num_sats_solution is None:
        self.num_sats_solution = 0
      if self.cn0 is None:
        self.cn0 = []
      if self.correction_age is None:
        self.correction_age = 0.
    else:
      self.receiver_type = 0
      self.position_fix_type = 0
      self.heading_fix_type = 0
      self.num_connected_sats = 0
      self.num_sats_solution = 0
      self.cn0 = []
      self.correction_age = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_5B().pack(_x.receiver_type, _x.position_fix_type, _x.heading_fix_type, _x.num_connected_sats, _x.num_sats_solution))
      length = len(self.cn0)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.Struct(pattern).pack(*self.cn0))
      _x = self.correction_age
      buff.write(_get_struct_d().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 5
      (_x.receiver_type, _x.position_fix_type, _x.heading_fix_type, _x.num_connected_sats, _x.num_sats_solution,) = _get_struct_5B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.cn0 = s.unpack(str[start:end])
      start = end
      end += 8
      (self.correction_age,) = _get_struct_d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_5B().pack(_x.receiver_type, _x.position_fix_type, _x.heading_fix_type, _x.num_connected_sats, _x.num_sats_solution))
      length = len(self.cn0)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.cn0.tostring())
      _x = self.correction_age
      buff.write(_get_struct_d().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 5
      (_x.receiver_type, _x.position_fix_type, _x.heading_fix_type, _x.num_connected_sats, _x.num_sats_solution,) = _get_struct_5B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.cn0 = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      start = end
      end += 8
      (self.correction_age,) = _get_struct_d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_5B = None
def _get_struct_5B():
    global _struct_5B
    if _struct_5B is None:
        _struct_5B = struct.Struct("<5B")
    return _struct_5B
_struct_d = None
def _get_struct_d():
    global _struct_d
    if _struct_d is None:
        _struct_d = struct.Struct("<d")
    return _struct_d
