# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from clearpath_localization_msgs/LocalizationStatus.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import clearpath_localization_msgs.msg
import std_msgs.msg

class LocalizationStatus(genpy.Message):
  _md5sum = "166e5ca90227080fd9ba0eedbef721ee"
  _type = "clearpath_localization_msgs/LocalizationStatus"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """# # Message definition containing localization status information for all sources of localization

std_msgs/Header header
# the localization accuracy as a percentage value (covariance?)
float32 accuracy # in development

# status information related to the GPS receiver units
GNSSStatus position_gnss
GNSSStatus heading_gnss
GNSSStatus base_station_gnss

bool dead_reckoning
================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: clearpath_localization_msgs/GNSSStatus
# Message definition containing the GNSS receiver status information.

uint8 POSITION_RECEIVER = 0
uint8 HEADING_RECEIVER = 1
uint8 BASE_STATION_RECEIVER = 2
uint8 receiver_type

uint8 POSITION_NO_FIX = 0
uint8 POSITION_SPP = 1
uint8 POSITION_SBAS = 2
uint8 POSITION_RTK_FLOAT = 3
uint8 POSITION_RTK_FIXED = 4
uint8 position_fix_type

uint8 HEADING_NOT_APPLICABLE = 0
uint8 HEADING_NO_SOLUTION = 1
uint8 HEADING_RTK_FLOAT = 2
uint8 HEADING_RTK_FIXED = 3
uint8 heading_fix_type

uint8 num_connected_sats	# Number of satellites connected to the antenna/receiver
uint8 num_sats_solution   # Number of sats used in solution
float32[] cn0			        # The carrier-to-noise ratio of each connected satellite
float64 correction_age    # Age of RTK corrections. -1 indicates none received
"""
  __slots__ = ['header','accuracy','position_gnss','heading_gnss','base_station_gnss','dead_reckoning']
  _slot_types = ['std_msgs/Header','float32','clearpath_localization_msgs/GNSSStatus','clearpath_localization_msgs/GNSSStatus','clearpath_localization_msgs/GNSSStatus','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,accuracy,position_gnss,heading_gnss,base_station_gnss,dead_reckoning

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(LocalizationStatus, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.accuracy is None:
        self.accuracy = 0.
      if self.position_gnss is None:
        self.position_gnss = clearpath_localization_msgs.msg.GNSSStatus()
      if self.heading_gnss is None:
        self.heading_gnss = clearpath_localization_msgs.msg.GNSSStatus()
      if self.base_station_gnss is None:
        self.base_station_gnss = clearpath_localization_msgs.msg.GNSSStatus()
      if self.dead_reckoning is None:
        self.dead_reckoning = False
    else:
      self.header = std_msgs.msg.Header()
      self.accuracy = 0.
      self.position_gnss = clearpath_localization_msgs.msg.GNSSStatus()
      self.heading_gnss = clearpath_localization_msgs.msg.GNSSStatus()
      self.base_station_gnss = clearpath_localization_msgs.msg.GNSSStatus()
      self.dead_reckoning = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_f5B().pack(_x.accuracy, _x.position_gnss.receiver_type, _x.position_gnss.position_fix_type, _x.position_gnss.heading_fix_type, _x.position_gnss.num_connected_sats, _x.position_gnss.num_sats_solution))
      length = len(self.position_gnss.cn0)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.Struct(pattern).pack(*self.position_gnss.cn0))
      _x = self
      buff.write(_get_struct_d5B().pack(_x.position_gnss.correction_age, _x.heading_gnss.receiver_type, _x.heading_gnss.position_fix_type, _x.heading_gnss.heading_fix_type, _x.heading_gnss.num_connected_sats, _x.heading_gnss.num_sats_solution))
      length = len(self.heading_gnss.cn0)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.Struct(pattern).pack(*self.heading_gnss.cn0))
      _x = self
      buff.write(_get_struct_d5B().pack(_x.heading_gnss.correction_age, _x.base_station_gnss.receiver_type, _x.base_station_gnss.position_fix_type, _x.base_station_gnss.heading_fix_type, _x.base_station_gnss.num_connected_sats, _x.base_station_gnss.num_sats_solution))
      length = len(self.base_station_gnss.cn0)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.Struct(pattern).pack(*self.base_station_gnss.cn0))
      _x = self
      buff.write(_get_struct_dB().pack(_x.base_station_gnss.correction_age, _x.dead_reckoning))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.position_gnss is None:
        self.position_gnss = clearpath_localization_msgs.msg.GNSSStatus()
      if self.heading_gnss is None:
        self.heading_gnss = clearpath_localization_msgs.msg.GNSSStatus()
      if self.base_station_gnss is None:
        self.base_station_gnss = clearpath_localization_msgs.msg.GNSSStatus()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 9
      (_x.accuracy, _x.position_gnss.receiver_type, _x.position_gnss.position_fix_type, _x.position_gnss.heading_fix_type, _x.position_gnss.num_connected_sats, _x.position_gnss.num_sats_solution,) = _get_struct_f5B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.position_gnss.cn0 = s.unpack(str[start:end])
      _x = self
      start = end
      end += 13
      (_x.position_gnss.correction_age, _x.heading_gnss.receiver_type, _x.heading_gnss.position_fix_type, _x.heading_gnss.heading_fix_type, _x.heading_gnss.num_connected_sats, _x.heading_gnss.num_sats_solution,) = _get_struct_d5B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.heading_gnss.cn0 = s.unpack(str[start:end])
      _x = self
      start = end
      end += 13
      (_x.heading_gnss.correction_age, _x.base_station_gnss.receiver_type, _x.base_station_gnss.position_fix_type, _x.base_station_gnss.heading_fix_type, _x.base_station_gnss.num_connected_sats, _x.base_station_gnss.num_sats_solution,) = _get_struct_d5B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.base_station_gnss.cn0 = s.unpack(str[start:end])
      _x = self
      start = end
      end += 9
      (_x.base_station_gnss.correction_age, _x.dead_reckoning,) = _get_struct_dB().unpack(str[start:end])
      self.dead_reckoning = bool(self.dead_reckoning)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_f5B().pack(_x.accuracy, _x.position_gnss.receiver_type, _x.position_gnss.position_fix_type, _x.position_gnss.heading_fix_type, _x.position_gnss.num_connected_sats, _x.position_gnss.num_sats_solution))
      length = len(self.position_gnss.cn0)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.position_gnss.cn0.tostring())
      _x = self
      buff.write(_get_struct_d5B().pack(_x.position_gnss.correction_age, _x.heading_gnss.receiver_type, _x.heading_gnss.position_fix_type, _x.heading_gnss.heading_fix_type, _x.heading_gnss.num_connected_sats, _x.heading_gnss.num_sats_solution))
      length = len(self.heading_gnss.cn0)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.heading_gnss.cn0.tostring())
      _x = self
      buff.write(_get_struct_d5B().pack(_x.heading_gnss.correction_age, _x.base_station_gnss.receiver_type, _x.base_station_gnss.position_fix_type, _x.base_station_gnss.heading_fix_type, _x.base_station_gnss.num_connected_sats, _x.base_station_gnss.num_sats_solution))
      length = len(self.base_station_gnss.cn0)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.base_station_gnss.cn0.tostring())
      _x = self
      buff.write(_get_struct_dB().pack(_x.base_station_gnss.correction_age, _x.dead_reckoning))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.position_gnss is None:
        self.position_gnss = clearpath_localization_msgs.msg.GNSSStatus()
      if self.heading_gnss is None:
        self.heading_gnss = clearpath_localization_msgs.msg.GNSSStatus()
      if self.base_station_gnss is None:
        self.base_station_gnss = clearpath_localization_msgs.msg.GNSSStatus()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 9
      (_x.accuracy, _x.position_gnss.receiver_type, _x.position_gnss.position_fix_type, _x.position_gnss.heading_fix_type, _x.position_gnss.num_connected_sats, _x.position_gnss.num_sats_solution,) = _get_struct_f5B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.position_gnss.cn0 = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      _x = self
      start = end
      end += 13
      (_x.position_gnss.correction_age, _x.heading_gnss.receiver_type, _x.heading_gnss.position_fix_type, _x.heading_gnss.heading_fix_type, _x.heading_gnss.num_connected_sats, _x.heading_gnss.num_sats_solution,) = _get_struct_d5B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.heading_gnss.cn0 = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      _x = self
      start = end
      end += 13
      (_x.heading_gnss.correction_age, _x.base_station_gnss.receiver_type, _x.base_station_gnss.position_fix_type, _x.base_station_gnss.heading_fix_type, _x.base_station_gnss.num_connected_sats, _x.base_station_gnss.num_sats_solution,) = _get_struct_d5B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.base_station_gnss.cn0 = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      _x = self
      start = end
      end += 9
      (_x.base_station_gnss.correction_age, _x.dead_reckoning,) = _get_struct_dB().unpack(str[start:end])
      self.dead_reckoning = bool(self.dead_reckoning)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_d5B = None
def _get_struct_d5B():
    global _struct_d5B
    if _struct_d5B is None:
        _struct_d5B = struct.Struct("<d5B")
    return _struct_d5B
_struct_dB = None
def _get_struct_dB():
    global _struct_dB
    if _struct_dB is None:
        _struct_dB = struct.Struct("<dB")
    return _struct_dB
_struct_f5B = None
def _get_struct_f5B():
    global _struct_f5B
    if _struct_f5B is None:
        _struct_f5B = struct.Struct("<f5B")
    return _struct_f5B
