// Auto-generated. Do not edit!

// (in-package clearpath_localization_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let sensor_msgs = _finder('sensor_msgs');

//-----------------------------------------------------------

class SurveyProperties {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.last_survey_time = null;
      this.num_samples = null;
      this.base_location = null;
      this.success = null;
    }
    else {
      if (initObj.hasOwnProperty('last_survey_time')) {
        this.last_survey_time = initObj.last_survey_time
      }
      else {
        this.last_survey_time = '';
      }
      if (initObj.hasOwnProperty('num_samples')) {
        this.num_samples = initObj.num_samples
      }
      else {
        this.num_samples = 0;
      }
      if (initObj.hasOwnProperty('base_location')) {
        this.base_location = initObj.base_location
      }
      else {
        this.base_location = new sensor_msgs.msg.NavSatFix();
      }
      if (initObj.hasOwnProperty('success')) {
        this.success = initObj.success
      }
      else {
        this.success = false;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type SurveyProperties
    // Serialize message field [last_survey_time]
    bufferOffset = _serializer.string(obj.last_survey_time, buffer, bufferOffset);
    // Serialize message field [num_samples]
    bufferOffset = _serializer.uint32(obj.num_samples, buffer, bufferOffset);
    // Serialize message field [base_location]
    bufferOffset = sensor_msgs.msg.NavSatFix.serialize(obj.base_location, buffer, bufferOffset);
    // Serialize message field [success]
    bufferOffset = _serializer.bool(obj.success, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type SurveyProperties
    let len;
    let data = new SurveyProperties(null);
    // Deserialize message field [last_survey_time]
    data.last_survey_time = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [num_samples]
    data.num_samples = _deserializer.uint32(buffer, bufferOffset);
    // Deserialize message field [base_location]
    data.base_location = sensor_msgs.msg.NavSatFix.deserialize(buffer, bufferOffset);
    // Deserialize message field [success]
    data.success = _deserializer.bool(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += _getByteLength(object.last_survey_time);
    length += sensor_msgs.msg.NavSatFix.getMessageSize(object.base_location);
    return length + 9;
  }

  static datatype() {
    // Returns string type for a message object
    return 'clearpath_localization_msgs/SurveyProperties';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '979fa338e89b90120462bf478da66a99';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Message definition containing the base station survey properties
    
    # ISO 8601 date/time format of last successfull base station survey
    string last_survey_time
    
    # Number of samples used in survey
    uint32 num_samples
    
    # GPS location of the base station
    sensor_msgs/NavSatFix base_location
    
    # denotes a successfull base station survey
    bool success
    
    ================================================================================
    MSG: sensor_msgs/NavSatFix
    # Navigation Satellite fix for any Global Navigation Satellite System
    #
    # Specified using the WGS 84 reference ellipsoid
    
    # header.stamp specifies the ROS time for this measurement (the
    #        corresponding satellite time may be reported using the
    #        sensor_msgs/TimeReference message).
    #
    # header.frame_id is the frame of reference reported by the satellite
    #        receiver, usually the location of the antenna.  This is a
    #        Euclidean frame relative to the vehicle, not a reference
    #        ellipsoid.
    Header header
    
    # satellite fix status information
    NavSatStatus status
    
    # Latitude [degrees]. Positive is north of equator; negative is south.
    float64 latitude
    
    # Longitude [degrees]. Positive is east of prime meridian; negative is west.
    float64 longitude
    
    # Altitude [m]. Positive is above the WGS 84 ellipsoid
    # (quiet NaN if no altitude is available).
    float64 altitude
    
    # Position covariance [m^2] defined relative to a tangential plane
    # through the reported position. The components are East, North, and
    # Up (ENU), in row-major order.
    #
    # Beware: this coordinate system exhibits singularities at the poles.
    
    float64[9] position_covariance
    
    # If the covariance of the fix is known, fill it in completely. If the
    # GPS receiver provides the variance of each measurement, put them
    # along the diagonal. If only Dilution of Precision is available,
    # estimate an approximate covariance from that.
    
    uint8 COVARIANCE_TYPE_UNKNOWN = 0
    uint8 COVARIANCE_TYPE_APPROXIMATED = 1
    uint8 COVARIANCE_TYPE_DIAGONAL_KNOWN = 2
    uint8 COVARIANCE_TYPE_KNOWN = 3
    
    uint8 position_covariance_type
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: sensor_msgs/NavSatStatus
    # Navigation Satellite fix status for any Global Navigation Satellite System
    
    # Whether to output an augmented fix is determined by both the fix
    # type and the last time differential corrections were received.  A
    # fix is valid when status >= STATUS_FIX.
    
    int8 STATUS_NO_FIX =  -1        # unable to fix position
    int8 STATUS_FIX =      0        # unaugmented fix
    int8 STATUS_SBAS_FIX = 1        # with satellite-based augmentation
    int8 STATUS_GBAS_FIX = 2        # with ground-based augmentation
    
    int8 status
    
    # Bits defining which Global Navigation Satellite System signals were
    # used by the receiver.
    
    uint16 SERVICE_GPS =     1
    uint16 SERVICE_GLONASS = 2
    uint16 SERVICE_COMPASS = 4      # includes BeiDou.
    uint16 SERVICE_GALILEO = 8
    
    uint16 service
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new SurveyProperties(null);
    if (msg.last_survey_time !== undefined) {
      resolved.last_survey_time = msg.last_survey_time;
    }
    else {
      resolved.last_survey_time = ''
    }

    if (msg.num_samples !== undefined) {
      resolved.num_samples = msg.num_samples;
    }
    else {
      resolved.num_samples = 0
    }

    if (msg.base_location !== undefined) {
      resolved.base_location = sensor_msgs.msg.NavSatFix.Resolve(msg.base_location)
    }
    else {
      resolved.base_location = new sensor_msgs.msg.NavSatFix()
    }

    if (msg.success !== undefined) {
      resolved.success = msg.success;
    }
    else {
      resolved.success = false
    }

    return resolved;
    }
};

module.exports = SurveyProperties;
